/*
 * Sample for form lifecycle, validation, focusing, 
 * error provider, Show and ShowDialog, work with menu 
 *
*/

		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
				int.Parse(textBox1.Text);
			}
			catch
			{
				MessageBox.Show("A number expected");
				textBox1.Focus();
				errorProvider1.SetError(textBox1, "Number expected!");
				return;
			}
			errorProvider1.SetError(textBox1, null);

			Form2 form = new Form2();

			menuItem3.Enabled = !menuItem3.Enabled;
			menuItem3.Checked = true;

			form.Show();
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			MessageBox.Show("Loading");
			errorProvider1.SetError(textBox1, null);
		}

		private void formActivate(object sender, System.EventArgs e)
		{
			//MessageBox.Show("Activating");
			listBox1.Items.Add("Activated");
		}

		private void formDeactivated(object sender, System.EventArgs e)
		{
			//MessageBox.Show("Deactivated");
			listBox1.Items.Add("Deactivated");
		}

		private void formVisChanged(object sender, System.EventArgs e)
		{
			//MessageBox.Show("Visibility changed");
			listBox1.Items.Add("Visibility changed");
		}

		private void formClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			listBox1.Items.Add("Closing");
			if(DialogResult.No == MessageBox.Show("Closing", "Exit?", MessageBoxButtons.YesNo))
			{
				e.Cancel = true;
			}
		}

		private void formClosed(object sender, System.EventArgs e)
		{
			MessageBox.Show("Closed!");
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void textBox1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			try
			{
				int.Parse(textBox1.Text);
			}
			catch
			{
				e.Cancel = true;
				MessageBox.Show("A number expected");
			}
		}